<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>pyxmpp.sasl.core.PasswordManager</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="pyxmpp-module.html">Package&nbsp;pyxmpp</a> ::
        <a href="pyxmpp.sasl-module.html">Package&nbsp;sasl</a> ::
        <a href="pyxmpp.sasl.core-module.html">Module&nbsp;core</a> ::
        Class&nbsp;PasswordManager
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<!-- ==================== CLASS DESCRIPTION ==================== -->
<h1 class="epydoc">Class PasswordManager</h1><p class="nomargin-top"><span class="codelink"><a href="pyxmpp.sasl.core-pysrc.html#PasswordManager">source&nbsp;code</a></span></p>
<dl><dt>Known Subclasses:</dt>
<dd>
      <ul class="subclass-list">
<li><a href="pyxmpp.streamsasl.StreamSASLMixIn-class.html">streamsasl.StreamSASLMixIn</a></li>  </ul>
</dd></dl>

<hr />
<p>Base class for password managers.</p>
<p>Password manager is an object responsible for providing or verification
of authentication credentials.</p>
<p>All the methods of <a href="pyxmpp.sasl.core.PasswordManager-class.html" class="link">PasswordManager</a> class may be overriden in derived
classes for specific authentication and authorization policy.</p>

<!-- ==================== INSTANCE METHODS ==================== -->
<a name="section-InstanceMethods"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Instance Methods</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-InstanceMethods"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="__init__"></a><span class="summary-sig-name">__init__</span>(<span class="summary-sig-arg">self</span>)</span><br />
      Initialize a <a href="pyxmpp.sasl.core.PasswordManager-class.html" class="link">PasswordManager</a> object.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.core-pysrc.html#PasswordManager.__init__">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code class="link">unicode</code>,`str` tuple.</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.core.PasswordManager-class.html#get_password" class="summary-sig-name">get_password</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">username</span>,
        <span class="summary-sig-arg">realm</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">acceptable_formats</span>=<span class="summary-sig-default"><code class="variable-group">(</code><code class="variable-quote">'</code><code class="variable-string">plain</code><code class="variable-quote">'</code><code class="variable-group">)</code></span>)</span><br />
      Get the password for user authentication.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.core-pysrc.html#PasswordManager.get_password">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code class="link">bool</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.core.PasswordManager-class.html#check_password" class="summary-sig-name">check_password</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">username</span>,
        <span class="summary-sig-arg">password</span>,
        <span class="summary-sig-arg">realm</span>=<span class="summary-sig-default">None</span>)</span><br />
      Check the password validity.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.core-pysrc.html#PasswordManager.check_password">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code class="link">list</code> of <code class="link">unicode</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.core.PasswordManager-class.html#get_realms" class="summary-sig-name">get_realms</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Get available realms list.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.core-pysrc.html#PasswordManager.get_realms">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code class="link">unicode</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.core.PasswordManager-class.html#choose_realm" class="summary-sig-name">choose_realm</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">realm_list</span>)</span><br />
      Choose an authentication realm from the list provided by the server.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.core-pysrc.html#PasswordManager.choose_realm">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code class="link">bool</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.core.PasswordManager-class.html#check_authzid" class="summary-sig-name">check_authzid</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">authzid</span>,
        <span class="summary-sig-arg">extra_info</span>=<span class="summary-sig-default">None</span>)</span><br />
      Check if the authenticated entity is allowed to use given
authorization id.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.core-pysrc.html#PasswordManager.check_authzid">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.core.PasswordManager-class.html#get_serv_type" class="summary-sig-name">get_serv_type</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Return the service type for DIGEST-MD5 'digest-uri' field.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.core-pysrc.html#PasswordManager.get_serv_type">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.core.PasswordManager-class.html#get_serv_host" class="summary-sig-name">get_serv_host</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Return the host name for DIGEST-MD5 'digest-uri' field.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.core-pysrc.html#PasswordManager.get_serv_host">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.core.PasswordManager-class.html#get_serv_name" class="summary-sig-name">get_serv_name</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Return the service name for DIGEST-MD5 'digest-uri' field.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.core-pysrc.html#PasswordManager.get_serv_name">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code class="link">str</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.core.PasswordManager-class.html#generate_nonce" class="summary-sig-name">generate_nonce</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Generate a random string for digest authentication challenges.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.core-pysrc.html#PasswordManager.generate_nonce">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
</table>
<!-- ==================== METHOD DETAILS ==================== -->
<a name="section-MethodDetails"></a>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Method Details</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-MethodDetails"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
</table>
<a name="get_password"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">get_password</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">username</span>,
        <span class="sig-arg">realm</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">acceptable_formats</span>=<span class="sig-default"><code class="variable-group">(</code><code class="variable-quote">'</code><code class="variable-string">plain</code><code class="variable-quote">'</code><code class="variable-group">)</code></span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.core-pysrc.html#PasswordManager.get_password">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Get the password for user authentication.</p>
<p>[both client or server]</p>
<p>By default returns (None, None) providing no password. Should be
overriden in derived classes.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>username</code></strong> (: <code class="link">unicode</code>) - : the username for which the password is requested.</li>
        <li><strong class="pname"><code>realm</code></strong> (: <code class="link">unicode</code>) - : the authentication realm for which the password is
requested.</li>
        <li><strong class="pname"><code>acceptable_formats</code></strong> (: sequence of <code class="link">str</code>) - : a sequence of acceptable formats of the
password data. Could be &quot;plain&quot;, &quot;<a class="rst-reference external" href="md5:user:realm:password" target="_top">md5:user:realm:password</a>&quot; or any
other mechanism-specific encoding. This allows non-plain-text
storage of passwords. But only &quot;plain&quot; format will work with
all password authentication mechanisms.</li>
    </ul></dd>
    <dt>Returns: <code class="link">unicode</code>,`str` tuple.</dt>
        <dd>the password and its encoding (format).</dd>
  </dl>
</td></tr></table>
</div>
<a name="check_password"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">check_password</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">username</span>,
        <span class="sig-arg">password</span>,
        <span class="sig-arg">realm</span>=<span class="sig-default">None</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.core-pysrc.html#PasswordManager.check_password">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Check the password validity.</p>
<p>[server only]</p>
<p>Used by plain-text authentication mechanisms.</p>
<p>Retrieve a &quot;plain&quot; password for the <code class="link">username</code> and <code class="link">realm</code> using
<a href="pyxmpp.sasl.core.PasswordManager-class.html#get_password" class="link">self.get_password</a> and compare it with the password provided.</p>
<p>May be overrided e.g. to check the password against some external
authentication mechanism (PAM, LDAP, etc.).</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>username</code></strong> (: <code class="link">unicode</code>) - : the username for which the password verification is
requested.</li>
        <li><strong class="pname"><code>password</code></strong> (: <code class="link">unicode</code>) - : the password to verify.</li>
        <li><strong class="pname"><code>realm</code></strong> (: <code class="link">unicode</code>) - : the authentication realm for which the password
verification is requested.</li>
    </ul></dd>
    <dt>Returns: <code class="link">bool</code></dt>
        <dd><code class="link">True</code> if the password is valid.</dd>
  </dl>
</td></tr></table>
</div>
<a name="get_realms"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">get_realms</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.core-pysrc.html#PasswordManager.get_realms">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Get available realms list.</p>
<p>[server only]</p>
  <dl class="fields">
    <dt>Returns: <code class="link">list</code> of <code class="link">unicode</code></dt>
        <dd>a list of realms available for authentication. May be empty --
the client may choose its own realm then or use no realm at all.</dd>
  </dl>
</td></tr></table>
</div>
<a name="choose_realm"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">choose_realm</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">realm_list</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.core-pysrc.html#PasswordManager.choose_realm">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Choose an authentication realm from the list provided by the server.</p>
<p>[client only]</p>
<p>By default return the first realm from the list or <code class="link">None</code> if the list
is empty.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>realm_list</code></strong> (: sequence of <code class="link">unicode</code>) - : the list of realms provided by a server.</li>
    </ul></dd>
    <dt>Returns: <code class="link">unicode</code></dt>
        <dd>the realm chosen.</dd>
  </dl>
</td></tr></table>
</div>
<a name="check_authzid"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">check_authzid</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">authzid</span>,
        <span class="sig-arg">extra_info</span>=<span class="sig-default">None</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.core-pysrc.html#PasswordManager.check_authzid">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Check if the authenticated entity is allowed to use given
authorization id.</p>
<p>[server only]</p>
<p>By default return <code class="link">True</code> if the <code class="link">authzid</code> is <code class="link">None</code> or empty or it is
equal to extra_info[&quot;username&quot;] (if the latter is present).</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>authzid</code></strong> (: <code class="link">unicode</code>) - : an authorization id.</li>
        <li><strong class="pname"><code>extra_info</code></strong> (: mapping) - : information about an entity got during the
authentication process. This is a mapping with arbitrary,
mechanism-dependent items. Common keys are 'username' or
'realm'.</li>
    </ul></dd>
    <dt>Returns: <code class="link">bool</code></dt>
        <dd><code class="link">True</code> if the authenticated entity is authorized to use
the provided authorization id.</dd>
  </dl>
</td></tr></table>
</div>
<a name="get_serv_type"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">get_serv_type</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.core-pysrc.html#PasswordManager.get_serv_type">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Return the service type for DIGEST-MD5 'digest-uri' field.</p>
<p>Should be overriden in derived classes.</p>
  <dl class="fields">
    <dt>Returns:</dt>
        <dd>the service type (&quot;unknown&quot; by default)</dd>
  </dl>
</td></tr></table>
</div>
<a name="get_serv_host"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">get_serv_host</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.core-pysrc.html#PasswordManager.get_serv_host">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Return the host name for DIGEST-MD5 'digest-uri' field.</p>
<p>Should be overriden in derived classes.</p>
  <dl class="fields">
    <dt>Returns:</dt>
        <dd>the host name (&quot;unknown&quot; by default)</dd>
  </dl>
</td></tr></table>
</div>
<a name="get_serv_name"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">get_serv_name</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.core-pysrc.html#PasswordManager.get_serv_name">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Return the service name for DIGEST-MD5 'digest-uri' field.</p>
<p>Should be overriden in derived classes.</p>
  <dl class="fields">
    <dt>Returns:</dt>
        <dd>the service name or <code class="link">None</code> (which is the default).</dd>
  </dl>
</td></tr></table>
</div>
<a name="generate_nonce"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">generate_nonce</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.core-pysrc.html#PasswordManager.generate_nonce">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Generate a random string for digest authentication challenges.</p>
<p>The string should be cryptographicaly secure random pattern.</p>
  <dl class="fields">
    <dt>Returns: <code class="link">str</code></dt>
        <dd>the string generated.</dd>
  </dl>
</td></tr></table>
</div>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Sun May  8 13:35:04 2011
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
